
<template>
  <q-page class="flex">
    <div class="doc-container col-12">
      <div class="minheight-rows">
        <div class="row title-row items-center margin-bottom-20">
          <i class="fas fa-th-large" style="color: blue"></i>
          <div class="page-title">{{ $t('Applications') }}</div>
        </div>
        <div class="row title-row justify-end margin-bottom-20">
          <i class="fas fa-hdd">&nbsp;</i>
          <div class="page-info">{{ disk_info.free_disk }}/{{ disk_info.total_disk }} GB</div>
        </div>
        <div class="row gutter-xs justify-center margin-bottom-20">
          <div class="col-12">
            <q-table
              :data="filteredDownload"
              :columns="columns"
              row-key="bundle"
            >
              <template slot="top-left" slot-scope="props">
                <div class="col">
                  <div class="row" style="margin-bottom: 10px">
                    <div class="q-table-title"><i class="fas fa-cloud-download-alt"></i> {{ $t('application.downloaded') }}</div>
                  </div>
                  <div class="row">
                    <q-search clearable v-model="filterDownloaded" />
                  </div>
                </div>
              </template>

              <q-tr slot="header" slot-scope="props">
                <q-td>{{ $t('Bundle') }}</q-td>
                <q-td>{{ $t('Name') }}</q-td>
                <q-td class="align-center">{{ $t('state.Install') }}</q-td>
                <q-td class="align-center">{{ $t('state.Delete') }}</q-td>
              </q-tr>

              <q-tr slot="body" slot-scope="props" :props="props">
                <q-td key="bundle" :props="props">
                  <div class="row items-center justify-between no-wrap"><span class="text-italic">{{ props.row.bundle }}</span></div>
                </q-td>
                <q-td key="name" :props="props">
                  <div class="row items-center justify-between no-wrap">{{ props.row.name }}</div>
                </q-td>
                <q-td>
                  <div class="row justify-center no-wrap">
                    <q-btn size="sm"
                           round
                           dense
                           color="secondary"
                           icon="play_arrow"
                           v-on:click="installApp(props.row.bundle)"
                           class="q-mr-xs"
                           :disabled="props.row.currentState != props.row.targetState"
                    />
                  </div>
                </q-td>
                <q-td>
                  <div class="row justify-center no-wrap">
                    <q-btn size="sm"
                           round
                           dense
                           color="negative"
                           icon="delete_outline"
                           class="q-mr-xs"
                           :disabled="props.row.currentState != props.row.targetState"
                           v-on:click="deleteApp(props.row.bundle)" />
                  </div>
                </q-td>

              </q-tr>
            </q-table>
          </div>
        </div>
        <div class="row gutter-xs justify-center margin-bottom-20">
          <div class="col-12">
            <q-table
              :data="filteredInstalled"
              :columns="columns"
              row-key="bundle"
            >
              <template slot="top-left" slot-scope="props">
                <div class="col">
                  <div class="row" style="margin-bottom: 10px">
                    <div class="q-table-title"><i class="fas fa-laptop"></i> {{ $t('application.installed') }}</div>
                  </div>
                  <div class="row">
                    <q-search clearable v-model="filterInstalled" />
                  </div>
                </div>
              </template>
              <q-tr slot="header" slot-scope="props">
                <q-td>{{ $t('Bundle') }}</q-td>
                <q-td>{{ $t('Name') }}</q-td>
                <q-td class="align-center">{{ $t('state.Upgrade') }}</q-td>
                <q-td class="align-center">{{ $t('content.content') }}</q-td>
                <q-td class="align-center">{{ $t('Order') }}</q-td>
                <q-td class="align-center">{{ $t('state.visible') }}</q-td>
                <q-td class="align-center">{{ $t('state.Delete') }}</q-td>
              </q-tr>

              <q-tr slot="body"
                    slot-scope="props"
                    :props="props"
              >
                <q-td key="bundle" :props="props">
                  <div class="row items-center justify-between no-wrap">
                    <span class="text-italic">{{ props.row.bundle }}</span>
                  </div>
                </q-td>

                <q-td key="name" :props="props">
                  <div class="row items-center justify-between no-wrap">{{ props.row.name }}</div>
                </q-td>
                <q-td>
                  <div class="row justify-center no-wrap">
                    <q-btn size="sm"
                           round dense
                           color="warning"
                           icon="description"
                           v-if="appUpgradable(props.row.bundle)"
                           v-on:click="upgradeApp(props.row.bundle)"
                           :disabled="upgradeDisabled(props.row.bundle)"
                           class="q-mr-xs"
                    />
                  </div>
                </q-td>

                <q-td>
                  <div class="row justify-center no-wrap">
                    <q-btn size="sm"
                           round dense
                           :color="contentButtonColor(props.row.bundle)"
                           icon="description"
                           v-if="props.row.contentsLink!=null"
                           v-on:click="viewContent(props.row.bundle)"
                           class="q-mr-xs"
                    />
                  </div>
                </q-td>
                <q-td>
                  <div class="row justify-center no-wrap">
                    <q-btn-group rounded v-if="props.row.__index !== 0 && !isLast(props.row)">
                      <q-btn size="sm"
                             dense rounded
                             color="secondary"
                             icon="arrow_upward"
                             v-on:click="moveUp(props.row.bundle)"
                      />
                      <q-btn size="sm"
                             dense rounded
                             color="secondary"
                             icon="arrow_downward"
                             v-on:click="moveDown(props.row.bundle)"
                      />
                    </q-btn-group>
                    <q-btn-group rounded v-if="props.length > 1 && props.row.__index === 0">
                      <q-btn size="sm"
                             dense rounded
                             color="secondary"
                             class="solo-arrow"
                             icon="arrow_downward"
                             v-on:click="moveDown(props.row.bundle)"
                      />
                    </q-btn-group>
                    <q-btn-group rounded v-if="props.length > 1 && isLast(props.row)">
                      <q-btn size="sm"
                             dense rounded
                             color="secondary"
                             class="solo-arrow"
                             icon="arrow_upward"
                             v-on:click="moveUp(props.row.bundle)"
                      />
                    </q-btn-group>
                  </div>
                </q-td>

                <q-td>
                  <div class="row justify-center no-wrap">
                    <q-toggle v-model="props.row.visible"
                              v-on:input="toggleVisibility(props.row.bundle, ...arguments)"
                              checked-icon="visibility"
                              unchecked-icon="visibility_off"
                              :disabled="props.row.currentState != props.row.targetState"
                    />
                  </div>
                </q-td>
                <q-td>
                  <div class="row justify-center no-wrap">
                    <q-btn size="sm"
                           round dense
                           color="negative"
                           icon="delete_outline"
                           class="q-mr-xs"
                           :disabled="props.row.currentState != props.row.targetState"
                           v-on:click="uninstall(props.row.bundle)"
                    />
                  </div>
                </q-td>

              </q-tr>
            </q-table>
          </div>
        </div>
      </div>
    </div>

  </q-page>
</template>

<script>
import {mapActions, mapState} from 'vuex'
import _ from 'lodash'

export default {
  name: 'Applications',
  data: () => ({
    columns: [
      {
        name: 'bundle',
        label: 'Bundle',
        required: true,
        visible: false
      },
      {
        name: 'name',
        label: 'Name',
        required: true,
        sortable: false

      },
      {
        name: 'commands',
        label: '',
        required: true,
        sortable: false,
        align: 'right'
      }
    ],
    filterDownloaded: '',
    filterInstalled: ''
  }),
  methods: {
    ...mapActions('applications', [
      'listInstalledApps',
      'listDownloadedApps',
      'triggerAppInstallation',
      'triggerAppUpgrade',
      'triggerAppUninstall',
      'triggerAppDeletion',
      'toggleVisible',
      'moveAppUp',
      'moveAppDown',
      'getFreeDiskSpace'
    ]),
    installApp: function (bundle) {
      this.triggerAppInstallation(bundle)
      this.$q.notify({
        message: `Installation`,

        timeout: 3000,
        // Available values: 'positive', 'negative', 'warning', 'info'
        type: 'info',
        detail: this.$t('application.will_install'),
        position: 'top-right'

      })
    },
    upgradeApp: function (bundle) {
      this.triggerAppUpgrade(bundle)
    },
    configureApp: function (bundle) {
      this.$router.push(`/applications/${bundle}/configuration`)
    },
    refreshStateTimeout: function () {
      this.listInstalledApps()
      this.listDownloadedApps()
      this.getFreeDiskSpace()
    },
    enableCheckTimeout: function () {
      this.timeoutInterval = setInterval(() => {
        this.refreshStateTimeout()
      }, 5000)
    },
    viewContent: function (bundle) {
      this.$router.push('/applications/' + bundle + '/contents')
    },
    appUpgradable: function (bundle) {
      let app = _.find(this.installed_applications, a => a.bundle === bundle)

      return app.currentVersion !== app.repositoryVersion
    },
    upgradeDisabled: function (bundle) {
      let app = _.find(this.installed_applications, a => a.bundle === bundle)

      return app.targetVersion === app.repositoryVersion
    },
    uninstall: function (bundle) {
      this.$q.dialog({
        title: this.$t('application.uninstall'),
        message: this.$t('application.uninstall_confirm'),
        ok: this.$t('state.Uninstall'),
        cancel: this.$t('Cancel')
      }).then(() => {
        this.$q.notify({
          message: this.$t('state.Uninstalled'),
          timeout: 3000,
          type: 'positive',
          icon: 'delete',
          detail: this.$t('application.uninstall_confirmation'),
          position: 'top-right'
        })
        this.triggerAppUninstall(bundle)
      })
    },
    deleteApp: function (bundle) {
      this.$q.dialog({
        title: this.$t('application.Delete'),
        message: this.$t('application.deleted_confirm'),
        ok: this.$t('state.Delete'),
        cancel: this.$t('Cancel')
      }).then(() => {
        this.$q.notify({
          message: this.$t('state.Deleted'),
          timeout: 3000,
          type: 'positive',
          icon: 'delete',
          detail: this.$t('application.deleted_confirmation'),
          position: 'top-right'
        })
        this.triggerAppDeletion(bundle)
      })
    },
    contentButtonColor: function (bundle) {
      let app = _.find(this.installed_applications, a => a.bundle === bundle)

      if (app.hasContentToUpgrade) {
        return 'warning'
      } else {
        return 'secondary'
      }
    },
    iconVisibility: function (bundle) {
      let app = _.find(this.installed_applications, a => a.bundle === bundle)

      if (app.visible) {
        return 'visibility_off'
      }
      return 'visibility'
    },
    visibility: function (bundle) {
      let app = _.find(this.installed_applications, a => a.bundle === bundle)
      return app.visible
    },
    toggleVisibility: function (bundle, newVal) {
      this.toggleVisible({bundle, newVal})
    },
    moveUp: function (bundle) {
      this.moveAppUp(bundle)
    },
    moveDown: function (bundle) {
      this.moveAppDown(bundle)
    },
    isLast: function (row) {
      return row.__index === (this.installed_applications.length - 1)
    }
  },
  computed: {
    filteredDownload: function () {
      if (!this.filterDownloaded) {
        return this.downloaded_applications
      }
      return this.downloaded_applications.filter(app => app.name.toLowerCase().includes(this.filterDownloaded.toLowerCase()) ||
              app.bundle.toLowerCase().includes(this.filterDownloaded.toLowerCase()))
    },
    filteredInstalled: function () {
      if (!this.filterInstalled) {
        return this.installed_applications
      }
      return this.installed_applications.filter(app => app.name.toLowerCase().includes(this.filterInstalled.toLowerCase()) ||
              app.bundle.toLowerCase().includes(this.filterInstalled.toLowerCase()))
    },
    ...mapState('applications', {
      installed_applications: (state) => state.installed_applications,
      downloaded_applications: (state) => state.downloaded_applications,
      disk_info: (state) => state.sysinfo
    })
  },
  mounted: function () {
    this.refreshStateTimeout()
    this.enableCheckTimeout()
  },
  destroyed: function () {
    clearInterval(this.timeoutInterval)
  }

}
</script>
